/* 
    File: ISTest4.C
*/

#include <string>
#include <iostream>

#include "ISTable.h"

using namespace std;


// prototypes

void FillTestTable(ISTable *s);
void PrintArray(const vector<unsigned int>& target);

int main(int argc, char** argv)
{

  ISTable *ss;
  string fname;
  vector<string> list;
  vector<string> list2;
  vector<string> list3;
  vector<string> list4;
  int recNo;
  int size;
  vector<unsigned int> listOut;

  ss = new ISTable();
  FillTestTable(ss);

  vector<string> colNames;
  ss->GetColumnNames(colNames); 

  list.push_back(colNames[0]);
  list.push_back(colNames[1]);

  list3.push_back("lp_lenght");
  list3.push_back("end_v");

  ss->CreateIndex("index0",list);
  ss->CreateIndex("index1",list3);

  vector<string>* newRow;
  newRow = new vector<string>;

  newRow->push_back("18");
  newRow->push_back("31");
  newRow->push_back("new");

  ss->AddRow();
  ss->FillRow(ss->GetLastRowIndex(), *newRow);

  ss->AddRow();
  ss->FillRow(ss->GetLastRowIndex(), *newRow);

  list2.push_back("18");
  list2.push_back("31");
  list4.push_back("new");
  list4.push_back("31");
  ss->DeleteRow(31);

  ss->AddRow();
  cout<<"GetNumRows = "<<ss->GetNumRows()<<endl;
  ss->FillRow(ss->GetLastRowIndex(), *newRow);

  ss->ClearRow(39);
  recNo=ss->FindFirst(list4, list3);
  cout<<"recNo = "<<recNo<<endl;

  ss->DeleteRow(49);
  ss->Search(listOut, list2, list);
  PrintArray(listOut);

  fname = "outfile.tdb";

  FileNavigator *fnav;
  int err;
  fnav = new FileNavigator();
  err=fnav->OpenFile(fname, CREATE_MODE, 1);
  if (err) fnav->PrintError(err);
  err=fnav->ReadFileHeader();
  if (err) fnav->PrintError(err);
  err = ss->WriteObject(fnav, size);
  fnav->CloseFile();
  delete fnav;

  fnav = new FileNavigator();
  ISTable gnu;
  fnav->OpenFile("outfile.tdb", READ_MODE,0);
  fnav->ReadFileHeader();
  gnu.GetObject(err, fnav);
  recNo=gnu.FindFirst(list2,list,"index0");
  cout<<"recNo = "<<recNo<<endl;
  recNo=gnu.FindFirst(list4, list3, "index1");
  cout<<"recNo = "<<recNo<<endl;
//  gnu.PrintTable();

  delete newRow;
  delete ss;
  fnav->CloseFile();
  delete fnav;
  exit(0);
}


void FillTestTable(ISTable *s) {
 int i;
 vector<string>* ColStart;
 vector<string>* ColEnd;
 vector<string>* ColLen;
 ColStart = new vector<string>;
 ColEnd = new vector<string>;
 ColLen = new vector<string>;
 string length;
 char a[5];
 s->AddColumn("start_v");
 s->AddColumn("end_v");
 s->AddColumn("lp_lenght");
 for (i=0; i<50; i++) {
   sprintf(a,"%d",49-i);
   length = a;
	ColStart->push_back(length);
   sprintf(a,"%d",i);
   length = a;
	ColEnd->push_back(length);
	ColLen->push_back(length);
 }

 s->FillColumn("start_v", *ColStart);
 s->FillColumn("end_v", *ColEnd);
 s->FillColumn("lp_lenght", *ColLen);

 delete ColStart;
 delete ColEnd;
 delete ColLen;
}



void PrintArray(const vector<unsigned int>& target) {
  if (!target.empty()) {
    int len = target.size();
    for (int i = 0; i < len - 1; i++) {
      cout << target[i] << ", ";
    }
    if (len > 0)
      cout << target[len - 1];
  }
  cout << endl;
}
