#include <iostream>
#include "GenString.h"
#include "TableFile.h"


int CompareTablesTrivial(ISTable * a, ISTable * b);
int CompareStringArrays(vector<string>& a, vector<string>& b);
void FillTestTable(ISTable *s, int nrows, int ncols, const string& fillPattern);


int main() {

  ISTable * s=NULL, *t = NULL;

  string tableLabel, blockLabel;
  //    int i,j, nblocks=5, ntables=100, nRows=100, nCols=10;
    unsigned int i, j, nblocks=2, ntables=2;
    unsigned int nRows = 10;
    unsigned int nCols = 10;

  
  //
  //  Create a test file 
  //
  TableFile * fobjR = new TableFile(CREATE_MODE, "./test9.sdb");
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    fobjR->AddBlock(blockLabel);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = new ISTable(tableLabel);
      FillTestTable(s, nRows, nCols, "ABCDEFGHIJKLMNOPQRSTUVWXYZ012345689");
      block.WriteTable(s);
      // ierr = fobjR->WriteTable(s,blockLabel);
      //      cerr << " i " << i << " j " << j << " error " << ierr << endl;
    }
  }
  //  s=fobjR->GetTablePtr(blockLabel,tableLabel);
  //  s->PrintTable();
  //  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  //  cerr << "PrintHeaderInfo() - Write Test I - Before CloseFile()" << endl;
  //  fobjR->PrintHeaderInfo();

  fobjR->Close();
  if (fobjR) delete fobjR;

  cerr << "Passed - Write Test I" << endl;



  //
  // Read and check the test file (Pass I)
  //

  fobjR = new TableFile(READ_MODE, "./test9.sdb");
  Block& blockR = fobjR->GetBlock("Block-1");
  t = blockR.GetTablePtr("Table-1");
  if (t == NULL)
  {
    cerr << "No table Table-1 in block Block-1" << endl;
    exit(1);
  }

  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }
  fobjR->Close();
  if (fobjR) delete fobjR;
  cerr << "Passed - Read Test I" << endl;

  //
  // Read and check the test file (Pass II)
  //


  fobjR = new TableFile(READ_MODE, "./test9.sdb");
  Block& blockR1 = fobjR->GetBlock("Block-1");
  t = blockR1.GetTablePtr("Table-1");
  if (t == NULL)
  {
    cerr << "No table Table-1 in block Block-1" << endl;
    exit(1);
  }

  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }
  fobjR->Close();
  if (fobjR) delete fobjR;
  cerr << "Passed - Read Test II" << endl;

  //
  // Read and check the test file in APPEND MODE (Pass I)
  //


  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "Beginning - Append Mode Test I" << endl;
  fobjR = new TableFile(UPDATE_MODE, "./test9.sdb");

  //  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  //  cerr << "PrintHeaderInfo() - Append Mode Test I" << endl;
  //  fobjR->PrintHeaderInfo();

  //  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  //  cerr << "PrintIndex() - Append Mode Test I" << endl;
  //  fobjR->PrintIndex();

  Block& blockR5 = fobjR->GetBlock("Block-1");
  t = blockR5.GetTablePtr("Table-1");
  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }

  fobjR->Close();
  if (fobjR) delete fobjR;

  cerr << "Completed - Append Mode Test I" << endl;
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;

  //
  // Read and check the test file in APPEND MODE (Pass II)
  //
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "Beginning - Append Mode Test II" << endl;
  fobjR = new TableFile(UPDATE_MODE, "./test9.sdb");
  Block& blockR2 = fobjR->GetBlock("Block-1");

  //  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  //  cerr << "PrintHeaderInfo() - Append Mode Test I" << endl;
  //  fobjR->PrintHeaderInfo();

  //  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  //  cerr << "PrintIndex() - Append Mode Test II" << endl;
  //  fobjR->PrintIndex();
  //  fobjR->DumpFile();

  t = blockR2.GetTablePtr("Table-1");
  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }

  fobjR->Close();
  if (fobjR) delete fobjR;
  cerr << "Completed - Append Mode Test II" << endl;


  // *************************************************************
  //  Rewrite the test file 
  //
  fobjR = new TableFile(UPDATE_MODE, "./test9.sdb");
  Block& blockR3 = fobjR->GetBlock("Block-1");
  
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "Beginning - ReWrite Mode Test I" << endl;

  t = blockR3.GetTablePtr("Table-1");
  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }
  //
  //

  // This writes over all of the existing tables... UNSAFE... 
  // and ther is a leak because of that
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = new ISTable(tableLabel);
      FillTestTable(s, nRows, nCols, 
		    "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ012345689");
      block.WriteTable(s);
//            if (s)  delete s;
    }
  }

#if 0
  // This adds a new set of tables.. 
  //
  for (j=0; j < nblocks; j++) {
    blockLabel.Clear();
    blockLabel.Copy("New-Block-");
    blockLabel += String::IntToString(j);
    fobjR->AddBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.Clear();
      tableLabel.Copy("New-Table-");
      tableLabel += String::IntToString(i);
      s = new ISTable(tableLabel);
      FillTestTable(s, nRows, nCols, 
		    "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ012345689");
      fobjR->WriteTable(s,blockLabel);
//            if (s)  delete s;
    }
  }
#endif
  //jdw 
  fobjR->Flush();
  //fobjR->PrintHeaderInfo();
  fobjR->Close();
  if (fobjR) delete fobjR;
  cerr << "Passed     - ReWrite Test I" << endl;
  cerr << "Completed - Append Mode Test II" << endl;

  //
  // Read and check the test file in APPEND MODE (Pass III)
  //
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "Beginning - Append Mode Test III" << endl;
  fobjR = new TableFile(UPDATE_MODE, "./test9.sdb");
  Block& blockR4 = fobjR->GetBlock("Block-1");
  t = blockR4.GetTablePtr("Table-1");
  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.clear();
    blockLabel = "Block-";
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.clear();
      tableLabel = "Table-";
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }
#if 0
  t = fobjR->GetTablePtr("New-Block-1","New-Table-1");
  if ((t->GetNumRows() != nRows) || (t->GetNumColumns() != nCols)) 
    cerr << "Table size corupted " << " rows " << t->GetNumRows() << " columns " 
	 << t->GetNumColumns() << endl;
  
  for (j=0; j < nblocks; j++) {
    blockLabel.Clear();
    blockLabel.Copy("New-Block-");
    blockLabel += String::IntToString(j);
    Block& block = fobjR->GetBlock(blockLabel);
    for (i=0; i < ntables; i++) {
      tableLabel.Clear();
      tableLabel.Copy("New-Table-");
      tableLabel += String::IntToString(i);
      s = block.GetTablePtr(tableLabel);
      CompareTablesTrivial(s,t) ;
    }
  }
#endif
  fobjR->Close();
  if (fobjR) delete fobjR;
  cerr << "Completed - Append Mode Test III" << endl;

  exit(0);
} 

void FillTestTable(ISTable *s, int nrows, int ncols, const string& fillPattern) {
 string colLabel, rowData;
 int i,j;

 for (i=0; i < ncols; i++) {
   colLabel.clear();
   colLabel = "Column-";
   colLabel += String::IntToString(i);
   s->AddColumn(colLabel);
 }
 vector<string> newRow;
 for (j = 0; j < nrows; j++) {
   s->AddRow();
   newRow.clear();
   for (i=0; i < ncols; i++) {
     rowData.clear();
     rowData = "R-";
     rowData += String::IntToString(j);
     rowData += "-C-";
     rowData += String::IntToString(i);
     rowData += fillPattern;
     newRow.push_back(rowData);
   }
   s->FillRow(j, newRow);
 }
}

int CompareTablesTrivial(ISTable * a, ISTable * b) {

  vector<string> a1;
  vector<string> b1;
  vector<string> a1ColNames;
  vector<string> b1ColNames;

  int x1, x2, y1, y2, i,j;

  //  cerr << "Comparing tables " <<  a->GetName() << " and " << b->GetName() << endl;

  x1 = a->GetNumRows();
  x2 = b->GetNumRows();
  if (x1 != x2) {
    cerr << "Tables non-equivalent" << endl;
    cerr << "Comparing tables " <<  a->GetName() << " has row length " << x1 << endl;
    cerr << "Comparing tables " <<  b->GetName() << " has row length " << x2 << endl;
    return -1;
  }

  y1 = a->GetNumColumns();
  y2 = b->GetNumColumns();

  if (y1 != y2) {
    cerr << "Tables non-equivalent" << endl;
    cerr << "Comparing tables " <<  a->GetName() << " has column length " << y1 << endl;
    cerr << "Comparing tables " <<  b->GetName() << " has column length " << y2 << endl;
    return -2;
  }

  a->GetColumnNames(a1ColNames);
  b->GetColumnNames(b1ColNames);

  if (CompareStringArrays(a1, b1)) {
    cerr << "Tables non-equivalent" << endl;
    cerr << "Column names are not equivalent." << endl;
    return -3;
  }
  a1.clear();
  b1.clear();


  for (i = 0; i < x1; i++) {
    a->GetRow(a1, i);
    b->GetRow(b1, i);
    if (CompareStringArrays(a1, b1)) {
     cerr << "Tables non-equivalent" << endl;
     cerr << "Mismatch detected in row " << i << endl;
     for (j=0; j < (int)a1.size(); j++) {
       cerr << "Column [" << j << "] "<< a1[j] << b1[j] << endl;
     }
     return (-4 - i);
    }
    a1.clear();
    b1.clear();
  }

  for (i = 0; i < y1; i++) {
    a->GetColumn(a1, a1ColNames[i]);
    b->GetColumn(b1, b1ColNames[i]);
    if (CompareStringArrays(a1, b1)) {
     cerr << "Tables non-equivalent" << endl;
     cerr << "Mismatch detected in column " << i << endl;
     for (j=0; j < (int)a1.size(); j++) {
       cerr << "Row [" << j << "] "<< a1[j] << b1[j] << endl;
     }
     return (-4 - x1 - i);
    }
    a1.clear();
    b1.clear();
  }
  return 1;
}



int CompareStringArrays(vector<string>& a, vector<string>& b) {
  if ((a.empty()) && (b.empty())) return 0;
  if (a.empty()) return -1;
  if (b.empty()) return -2;
  int alen = a.size();
  int blen = b.size();
  if (alen != blen) return -3;
  for (int i = 0; i < alen; i++) {
    if (a[i] != b[i])
      return (-4 - i);
  }

  return 0;
}
